<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Using Existing Variables</TITLE>
<link href="builder_13.html" rel=Next>
<link href="builder_11.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_11.html">previous</A>, <A HREF="builder_13.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC27" HREF="builder_toc.html#TOC27">Using Existing Variables from SUIF</A></H2>
<P>
<A NAME="IDX75"></A>
<A NAME="IDX76"></A>
The variable symbols in SUIF are represented by <CODE>var_sym</CODE>s.  A
builder <CODE>block</CODE> can be created for a <CODE>var_sym</CODE> to use that
variable in the builder system. 
See section <A HREF="builder_36.html#SEC67">Using Variables</A> for more details.

</P>

<PRE>
        var_sym * var = (variable in SUIF)
        block v(var);
</PRE>

<P>
<A NAME="IDX77"></A>

</P>


<H3><A NAME="SEC28" HREF="builder_toc.html#TOC28">Accessing a Field of a Structure</A></H3>
<P>
<A NAME="IDX78"></A>
<A NAME="IDX79"></A>
<A NAME="IDX80"></A>
When accessing variables defining structures, each of the structure's
elements can be accessed using the <CODE>field()</CODE> function by either
specifying the name of the field or the field id.

<PRE>
        type_node * tn = block::parse_type("struct { int a; int b }");
        block var(block::new_sym(tn, "var");
        block body(block(var.field("a") = block(0)),
                   block(var.field("b") = block(0)));
</PRE>

<P>
<A NAME="IDX81"></A>
<A NAME="IDX82"></A>
<A NAME="IDX83"></A>
The builder code will create a structure variable and
initialize the fields to zero.

</P>
<P>
<STRONG>Note:</STRONG> In the current builder implementation, accessing a
structure field is limited to simple fields of structure variables. 
Composite operators such as accessing structures within structures or
dereferencing a pointer to access a field in a structure are not
implemented in the current version.

</P>


<H3><A NAME="SEC29" HREF="builder_toc.html#TOC29">Pointer Operations</A></H3>
<P>
<A NAME="IDX84"></A>
<A NAME="IDX85"></A>
<A NAME="IDX86"></A>
A value pointed to by a pointer can be accessed using the <CODE>dref()</CODE>
function. The address of a variable can be taken using the <CODE>addr()</CODE>
operator. 
The only operator that is not overloaded in <CODE>block</CODE> is
the dereference operator <CODE>*</CODE> (see section <A HREF="builder_14.html#SEC33">Creating Expressions and Statements</A>).

</P>

<PRE>
        type_node * tn = (any type)
        type_node * ptn = block::parse_type("* %%", tn);
        block val(block::new_sym(tn, "val"));
        block ptr(block::new_sym(ptn, "prt_val"));
        block body(block(ptr = val.addr()),
                   block(ptr.dref() = block(0)));
</PRE>

<P>
<A NAME="IDX87"></A>
<A NAME="IDX88"></A>
<A NAME="IDX89"></A>
The above code will create a variable of a given type and a pointer
variable to that type.  It will also assign the pointer to the data and
initialize the data to zero using the pointer.

</P>


<H3><A NAME="SEC30" HREF="builder_toc.html#TOC30">Array Accesses</A></H3>
<P>
<A NAME="IDX90"></A>
Elements of an array can be accessed in the same way as in C. Another
method to access array elements is by using the <CODE>ARRAY()</CODE> function.
The first argument to the function is the <CODE>block</CODE> representing the
array variable. The <CODE>block</CODE> structures representing the access
functions are given as subsequent arguments.

<PRE>
        var_sym * vs_i = (index variable from SUIF)
        type_node * tn = block::parse_type("int [100][100]");
        block A(tn, "A");
        block i(vs_i);
        block body(A[i][block(0)] = A[block(i+block(1))][block(0)]);
</PRE>

<P>
<A NAME="IDX91"></A>
<A NAME="IDX92"></A>

</P>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_11.html">previous</A>, <A HREF="builder_13.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
